<CsoundSynthesizer>
<CsOptions>

;-odac:1 -iadc:1 -d -b1024 -B1024 -+rtaudio=CoreAudio -+rtmidi=null
; for internal speakers
;-m0 -odac -iadc -d -+rtaudio=CoreAudio -+rtmidi=null

-d -g -W -oBambooFlute1.wav

</CsOptions>
<CsInstruments>

;***************** Dan Gutwein - WOOD FLUTE ****************
; Based on Hans Mikelson's 1/22/97 physical modeling code  *
; which was based on Perry Cook's Slide Flute              *
; Stphane Rollandin <lecteur@zogotounga.net>
;***********************************************************
;sr = 16000
;kr = 1600
ksmps =  10
nchnls = 2

instr 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16

; iamp is overall volume of the note-event

; krelamp is relative volume needed to produce equal volumes for each overblow segment of the overall note-event

; kgenamp is the expressive control over krelamp within the note-event
 

  aflute1 init 0

  idur = p3

  iamp = p4*64 ;(127*64 = 8128)

  ifreq    = cpspch(p5+2)

  ibthatk = p7

  ipan = .5

  ifeedbk1= .4

  ifeedbk2= .4

  ;ifreq and ibreath are adjusted by linsegs below

  

  ; Copy Overblow values for each pt. in linseg into variables

  ; from tables 10-13

  iOB1 table 	p40, 10  

  iOB2 table	p41, 10

  iOB3 table    p42, 10

  iOB4 table    p43, 10

  iOB5 table    p44, 10

  iOB6 table    p45, 10

  iOB7 table    p46, 10

  iOB8 table    p44, 10

  iOB9 table    p48, 10

  iOB10 table    p49, 10

  

  iVol1 table    p40, 11

  iVol2 table    p41, 11

  iVol3 table    p42, 11

  iVol4 table    p43, 11

  iVol5 table    p44, 11

  iVol6 table    p45, 11

  iVol7 table    p46, 11

  iVol8 table    p47, 11

  iVol9 table    p48, 11

  iVol10 table    p49, 11
 

  iBth1  table    p40, 12

  iBth2  table    p41, 12

  iBth3  table    p42, 12

  iBth4  table    p43, 12

  iBth5  table    p44, 12

  iBth6  table    p45, 12

  iBth7  table    p46, 12

  iBth8  table    p47, 12

  iBth9  table    p48, 12

  iBth10 table    p49, 12

  

  iAir1  table    p40, 13

  iAir2  table    p41, 13

  iAir3  table    p42, 13

  iAir4  table    p43, 13

  iAir5  table    p44, 13

  iAir6  table    p45, 13

  iAir7  table    p46, 13

  iAir8  table    p47, 13

  iAir9  table    p48, 13

  iAir10 table    p49, 13    	

 

;Convert Additive Notation of durations to % of idur 

;to be used in linseg below

	idur1 = p80 ; LITERAL SECONDS

	isubdiv = (idur-idur1)/(p81+p82+p83+p84+p85+p86+p87+p88) ; The rest are proportional

	idur2 = isubdiv*p81 

	idur3 = isubdiv*p81

	idur4 = isubdiv*p83

	idur5 = isubdiv*p84

	idur6 = isubdiv*p85

	idur7 = isubdiv*p86

	idur8 = isubdiv*p87

	idur9 = isubdiv*p88 

	

; EXPRESSION CONTROL - All linseg time-varying parameters  

  kvibamp    linseg p10 , idur1, p11, idur2, p12, idur3, p13, idur4, p14, idur5, p15, idur6, p16, idur7, p17, idur8, p18, idur9, p19 

  kvibspd    linseg p20 , idur1, p21, idur2, p22, idur3, p23, idur4, p24, idur5, p25, idur6, p26, idur7, p27, idur8, p28, idur9, p29     

  kpan       linseg p30 , idur1, p31, idur2, p32, idur3, p33, idur4, p34, idur5, p35, idur6, p36, idur7, p37, idur8, p38, idur9, p39     

  koverblow  linseg iOB1 , idur1, iOB2, idur2, iOB3, idur3, iOB4, idur4, iOB5, idur5, iOB6, idur6, iOB7, idur7, iOB8, idur8, iOB9, idur9, iOB10 

  kpressure  linseg iAir1, idur1, iAir2, idur2, iAir3, idur3, iAir4, idur4, iAir5, idur5, iAir6, idur6, iAir7, idur7, iAir8, idur8, iAir9, idur9, iAir10 

  krelbth    linseg iBth1*ibthatk , idur1, iBth2, idur2, iBth3, idur3, iBth4, idur4, iBth5, idur5, iBth6, idur6, iBth7, idur7, iBth8, idur8, iBth9, idur9, iBth10 

  krelamp    linseg 0,idur1, iVol2, idur2, iVol3, idur3, iVol4, idur4, iVol5, idur5, iVol6, idur6, iVol7, idur7, iVol8, idur8, iVol9, idur9, 0

  kgenamp    linseg p50,idur1, p51, idur2, p52, idur3, p53, idur4, p54, idur5, p55, idur6, p56, idur7, p57, idur8, p58, idur9, p59

  kpchoffset linseg p60, idur1, p61, idur2, p62, idur3, p63, idur4, p64, idur5, p65, idur6, p66, idur7, p67, idur8, p68, idur9, p69

  kbthpct    linseg p70, idur1, p71, idur2, p72, idur3, p73, idur4, p74, idur5, p75, idur6, p76, idur7, p77, idur8, p78, idur9, p79

  

; Control the i-values

  ibreath = (p6*.01)

  

; The values must be approximately -1 to 1 or the cubic will blow up.

  aflow1 rand kpressure

  kpchvibr oscil kvibamp*.1, kvibspd, 3

  kbthvibr oscil kvibamp*.01, kvibspd, 3

  kbreath = ((ibreath*krelbth)*kbthpct)+kbthvibr; ibreath = overall ref. volume,  krelbth = bthvol. from table adjusted for overblows

                                                   ; kbthpct = the expressive changes to ibreath via linseg

 

 ; Compute the audio sample 

  asum1 = kbreath*aflow1 + kpressure + kpchvibr

  asum2 = asum1 + aflute1*ifeedbk1

  afqc  = 1/(ifreq+kpchoffset) - asum1/20000 -9/sr + (ifreq+kpchoffset)/12000000 ; Get the Pitch

  atemp1 delayr 1/ifreq/2  ; Embouchure delay should be 1/2 the bore delay

  ax     deltapi afqc/koverblow ; - asum1/ifreq/10 + 1/1000

         delayw asum2

  apoly = ax - ax*ax*ax

  asum3 = apoly+aflute1*ifeedbk2

  

  ; Filter audio source sums

  aout01 tone asum3, 2000

  aout02 tone asum3, 2000
 

; Bore, the bore length determines pitch.  Shorter is higher pitch.

   atemp2   delayr 1/ifreq

   aflute1 deltapi afqc

           delayw aout01

  

  outs (aout01*(iamp*(kgenamp*krelamp)))*kpan, (aout02*(iamp*(kgenamp*krelamp)))*(1-kpan)
 

endin

</CsInstruments>
<CsScore>

;********************  WOOD FLUTE DEMO - PHYSICAL MODEL ****************

;        Dan Gutwein (2000) via Hans Mikelson via Perry Cook's slide flute
 
 
 

; Tables holding normalizing values for Overblow, Amp, Bth-vol, & Air-Pressure

; These produce "flat" responses from each "overblow" setting.  Expressive values that

; further modify these results are listed in the score p-fields 40 and higher. Air Pressure

; values should produce equal volumes for each overblow setting when genamp p40-49 are set at 1.

;

; OVERBLOW VARIABLE EFFECTS: assuming air-pressure = 1:  	

; 2           = pure-tone (fundamental)

; 2.5  - 2.76 = upper m2nd lip-roll

; 2.77 - 2.89 =       m2nd lip-roll & slight harmonic at m7th above lip-roll (Db -  B nat.)

; 2.9  - 3.9 =   "   M7th above fundamental (B nat.) - full and clear

; 4.0  - 7.00 =   "   oct.

; 4.97 - 5.00 =   "   #11th (with soft flat-9th below #11)	

; 7.01 - 7.5  =   "   12th (.486 is more complex - realistic)

; 7.50 - 8.0   =  "   oct + M7th 

; 9.0          =  "   2 oct.

; 9.5 - 10.00  =  "   2 oct. & M3rd  

;

f3 0 1024 10 1  

f10 0 16 -2     2    2.76  2.76   2.89   3.6       4     4.7    5    7.486  8      9    10;  Overblow values

f11 0 16 -2     1    .7     2      3      1.3     .8     2     2     5.5    4.5    13   15;  Relative Amp Values per overblow value

f12 0 16 -2     1    .4    .4     .15    .5       .6    .20   .2     .075   .1    .03  .03;  Breath vol. per  overblow value

f13 0 16 -2    .89   1     .91    .903   .85      .89   .89    .899  .933   .942   .970   1   ;  Air Pressure per overblow value
 

t 0 60 
 
 

; The following section is generated by the <ELISP> code

;|begPublic Result

;-BEG-;

; (+k :pit 36 :dur 200 :vol 105)

i 1	0.0000	1.0417	798.8976	6.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1042	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 250)

i 1	1.0417	1.3021	798.8976	6.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1302	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 200)

i 1	2.3438	1.0417	798.8976	6.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1042	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 250)

i 1	3.3854	1.3021	798.8976	6.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1302	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 200)

i 1	4.6875	1.0417	798.8976	6.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1042	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 250)

i 1	5.7292	1.3021	798.8976	6.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1302	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 150 :vol 110)

i 1	7.0313	0.7813	820.6299	6.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0781	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 100)

i 1	7.8125	0.5208	820.6299	6.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0521	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 150)

i 1	8.3333	0.7813	820.6299	6.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0781	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 100)

i 1	9.1146	0.5208	820.6299	6.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0521	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 150 :vol 100)

i 1	9.6354	0.7813	778.9213	6.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0781	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 500 :vol 90)

i 1	10.4167	2.6042	810.9370	6.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.2604	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 493 :vol 127)

i 1	13.0208	2.5677	934.4000	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.2568	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 131)

i 1	15.5885	0.6823	934.4000	5.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0682	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 296)

i 1	16.2708	1.5417	934.4000	5.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1542	1	1	1	1	1	1	1	1

; (+k :pit 33)

i 1	17.8125	1.5417	934.4000	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1542	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 131)

i 1	19.3542	0.6823	934.4000	5.1100	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0682	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 35)

i 1	20.0365	0.1823	934.4000	6.1000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0182	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 79)

i 1	20.2188	0.4115	934.4000	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	20.6302	0.4115	934.4000	6.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 296 :time 4041)

i 1	21.0469	1.5417	934.4000	5.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1542	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 79)

i 1	22.5885	0.4115	934.4000	5.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 178)

i 1	23.0000	0.9271	934.4000	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 33 :time 4593)

i 1	23.9219	0.9271	934.4000	5.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 296 :time 4770)

i 1	24.8438	1.5417	934.4000	5.0900	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1542	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 79)

i 1	26.3854	0.4115	934.4000	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 178)

i 1	26.7969	0.9271	934.4000	5.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 42 :time 5322)

i 1	27.7188	0.9271	934.4000	6.0600	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 131)

i 1	28.6458	0.6823	934.4000	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0682	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 35)

i 1	29.3281	0.1823	934.4000	6.1000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0182	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 79)

i 1	29.5104	0.4115	934.4000	5.1100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	29.9219	0.4115	934.4000	6.0800	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 35)

i 1	30.3333	0.1823	934.4000	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0182	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 9)

i 1	30.5156	0.0469	934.4000	7.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 21)

i 1	30.5625	0.1094	934.4000	6.1000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	30.6719	0.1094	934.4000	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 79 :time 5911)

i 1	30.7865	0.4115	934.4000	5.1100	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 21)

i 1	31.1979	0.1094	934.4000	6.1000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47)

i 1	31.3073	0.2448	934.4000	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44 :time 6059)

i 1	31.5573	0.2448	934.4000	6.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 79 :time 6105)

i 1	31.7969	0.4115	934.4000	6.0800	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21)

i 1	32.2083	0.1094	934.4000	7.0700	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	32.3177	0.2448	934.4000	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 53 :time 6253)

i 1	32.5677	0.2448	934.4000	7.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 296)

i 1	32.8125	1.5417	934.4000	5.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1542	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 79)

i 1	34.3542	0.4115	934.4000	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 178)

i 1	34.7656	0.9271	934.4000	5.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 33 :time 6852)

i 1	35.6875	0.9271	934.4000	5.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 79)

i 1	36.6146	0.4115	934.4000	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 21)

i 1	37.0260	0.1094	934.4000	6.1000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47)

i 1	37.1354	0.2448	934.4000	5.1100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44 :time 7178)

i 1	37.3854	0.2448	934.4000	6.0800	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 178 :time 7224)

i 1	37.6250	0.9271	934.4000	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47)

i 1	38.5521	0.2448	934.4000	5.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 107)

i 1	38.7969	0.5573	934.4000	5.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 33 :time 7555)

i 1	39.3490	0.5573	934.4000	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 178)

i 1	39.9063	0.9271	934.4000	5.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	40.8333	0.2448	934.4000	6.0800	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 107)

i 1	41.0781	0.5573	934.4000	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 42 :time 7993)

i 1	41.6302	0.5573	934.4000	6.0600	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 296)

i 1	42.1875	1.5417	934.4000	5.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1542	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 79)

i 1	43.7292	0.4115	934.4000	6.0800	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 178)

i 1	44.1406	0.9271	934.4000	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 42 :time 8652)

i 1	45.0625	0.9271	934.4000	6.0600	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 79)

i 1	45.9896	0.4115	934.4000	6.0800	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21)

i 1	46.4010	0.1094	934.4000	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	46.5104	0.2448	934.4000	6.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 53 :time 8978)

i 1	46.7604	0.2448	934.4000	7.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 178 :time 9024)

i 1	47.0000	0.9271	934.4000	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	47.9271	0.2448	934.4000	6.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 107)

i 1	48.1719	0.5573	934.4000	5.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 42 :time 9355)

i 1	48.7240	0.5573	934.4000	6.0600	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 42 :dur 178)

i 1	49.2813	0.9271	934.4000	6.0600	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0927	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 47)

i 1	50.2083	0.2448	934.4000	7.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 42 :dur 107)

i 1	50.4531	0.5573	934.4000	6.0600	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 51 :time 9793)

i 1	51.0052	0.5573	934.4000	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0557	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 713 :vol 110)

i 1	51.5625	3.7135	791.7559	5.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.3714	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 238)

i 1	55.2760	1.2396	791.7559	5.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1240	1	1	1	1	1	1	1	1

; (+k :pit 35 :time 10850)

i 1	56.5104	1.2396	791.7559	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1240	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 79)

i 1	57.7500	0.4115	791.7559	6.1000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 238 :time 11166)

i 1	58.1563	1.2396	791.7559	5.1100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1240	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 79)

i 1	59.3958	0.4115	791.7559	6.1000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80)

i 1	59.8073	0.4167	791.7559	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	60.2240	0.1406	791.7559	7.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 238 :time 11588)

i 1	60.3542	1.2396	791.7559	5.1100	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1240	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 79)

i 1	61.5938	0.4115	791.7559	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80)

i 1	62.0052	0.4167	791.7559	6.1000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	62.4219	0.1406	791.7559	7.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80 :time 12010)

i 1	62.5521	0.4167	791.7559	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	62.9688	0.1406	791.7559	7.0900	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26 :time 12116)

i 1	63.1042	0.1354	791.7559	7.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	63.2396	0.0469	791.7559	8.0800	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 238 :time 12150)

i 1	63.2813	1.2396	791.7559	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1240	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 79)

i 1	64.5208	0.4115	791.7559	6.1000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80)

i 1	64.9323	0.4167	791.7559	6.1000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	65.3490	0.1406	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80 :time 12572)

i 1	65.4792	0.4167	791.7559	6.1000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	65.8958	0.1406	791.7559	7.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26 :time 12678)

i 1	66.0313	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	66.1667	0.0469	791.7559	8.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80)

i 1	66.2135	0.4167	791.7559	6.1000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	66.6302	0.1406	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26 :time 12819)

i 1	66.7656	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	66.9010	0.0469	791.7559	8.0800	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26)

i 1	66.9479	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	67.0833	0.0469	791.7559	8.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 68)

i 1	67.1302	0.0469	791.7559	8.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 79 :dur 3)

i 1	67.1771	0.0156	791.7559	9.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0016	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 238 :time 12900)

i 1	67.1875	1.2396	791.7559	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1240	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 79)

i 1	68.4271	0.4115	791.7559	6.1000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0411	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80)

i 1	68.8385	0.4167	791.7559	6.1000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	69.2552	0.1406	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80 :time 13322)

i 1	69.3854	0.4167	791.7559	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	69.8021	0.1406	791.7559	7.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26 :time 13428)

i 1	69.9375	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	70.0729	0.0469	791.7559	8.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80)

i 1	70.1198	0.4167	791.7559	6.1000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	70.5365	0.1406	791.7559	7.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26 :time 13569)

i 1	70.6719	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	70.8073	0.0469	791.7559	8.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26)

i 1	70.8542	0.1354	791.7559	7.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	70.9896	0.0469	791.7559	8.0800	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 68)

i 1	71.0365	0.0469	791.7559	8.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 79 :dur 3)

i 1	71.0833	0.0156	791.7559	9.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0016	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 80 :time 13650)

i 1	71.0938	0.4167	791.7559	6.1000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0417	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 27)

i 1	71.5104	0.1406	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0141	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26 :time 13756)

i 1	71.6458	0.1354	791.7559	7.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	71.7813	0.0469	791.7559	8.0800	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26)

i 1	71.8281	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	71.9635	0.0469	791.7559	8.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 68)

i 1	72.0104	0.0469	791.7559	8.0800	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 79 :dur 3)

i 1	72.0573	0.0156	791.7559	9.0700	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0016	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 26)

i 1	72.0729	0.1354	791.7559	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0135	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	72.2083	0.0469	791.7559	8.0800	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 68)

i 1	72.2552	0.0469	791.7559	8.0800	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 79 :dur 3)

i 1	72.3021	0.0156	791.7559	9.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0016	1	1	1	1	1	1	1	1

; (+k :pit 68 :dur 9)

i 1	72.3177	0.0469	791.7559	8.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 79 :dur 3)

i 1	72.3646	0.0156	791.7559	9.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0016	1	1	1	1	1	1	1	1

; (+k :pit 79)

i 1	72.3802	0.0156	791.7559	9.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0016	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 375 :vol 120)

i 1	72.3958	1.9531	839.8740	7.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1953	1	1	1	1	1	1	1	1

; (|k :pit 90 :dur 1 :vol 110)

i 1	72.3958	0.0052	847.9843	10.0600	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0005	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 188 :vol 120 :time 14275)

i 1	74.3490	0.9792	932.3228	7.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 48)

i 1	75.3281	0.9792	932.3228	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 57 :time 14650)

i 1	76.3021	0.9792	932.3228	7.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 94)

i 1	77.2813	0.4896	932.3228	7.0700	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 46 :time 14931)

i 1	77.7656	0.4896	932.3228	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 188)

i 1	78.2552	0.9792	932.3228	7.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94)

i 1	79.2344	0.4896	932.3228	6.1000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 37 :time 15306)

i 1	79.7188	0.4896	932.3228	6.0100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 188)

i 1	80.2083	0.9792	932.3228	7.0900	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 94)

i 1	81.1875	0.4896	932.3228	7.0700	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 46 :time 15681)

i 1	81.6719	0.4896	932.3228	6.1000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	82.1615	0.4896	932.3228	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 47)

i 1	82.6510	0.2448	932.3228	7.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	82.8958	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94)

i 1	83.1406	0.4896	932.3228	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	83.6302	0.2448	932.3228	6.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	83.8750	0.2448	932.3228	5.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 188 :time 16150)

i 1	84.1146	0.9792	932.3228	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94)

i 1	85.0938	0.4896	932.3228	6.1000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 37 :time 16431)

i 1	85.5781	0.4896	932.3228	6.0100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 46)

i 1	86.0677	0.4896	932.3228	6.1000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	86.5573	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	86.8021	0.2448	932.3228	5.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 37 :dur 94)

i 1	87.0469	0.4896	932.3228	6.0100	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47)

i 1	87.5365	0.2448	932.3228	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 26)

i 1	87.7813	0.2448	932.3228	5.0200	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 188 :time 16900)

i 1	88.0208	0.9792	932.3228	7.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 94)

i 1	89.0000	0.4896	932.3228	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 46 :time 17181)

i 1	89.4844	0.4896	932.3228	6.1000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	89.9740	0.4896	932.3228	7.0700	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 47)

i 1	90.4635	0.2448	932.3228	7.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	90.7083	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94)

i 1	90.9531	0.4896	932.3228	6.1000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	91.4427	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	91.6875	0.2448	932.3228	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 94 :time 17650)

i 1	91.9271	0.4896	932.3228	7.0700	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 47)

i 1	92.4167	0.2448	932.3228	7.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	92.6615	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	92.9063	0.2448	932.3228	7.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 24)

i 1	93.1510	0.1250	932.3228	7.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 42)

i 1	93.2760	0.1250	932.3228	6.0600	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47 :time 17931)

i 1	93.3906	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 42 :dur 24)

i 1	93.6354	0.1250	932.3228	6.0600	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 33)

i 1	93.7604	0.1250	932.3228	5.0900	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94 :time 18025)

i 1	93.8802	0.4896	932.3228	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	94.3698	0.2448	932.3228	6.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	94.6146	0.2448	932.3228	5.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	94.8594	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 42 :dur 24)

i 1	95.1042	0.1250	932.3228	6.0600	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 33)

i 1	95.2292	0.1250	932.3228	5.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47 :time 18306)

i 1	95.3438	0.2448	932.3228	5.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 24)

i 1	95.5885	0.1250	932.3228	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 24)

i 1	95.7135	0.1250	932.3228	5.0000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 188 :time 18400)

i 1	95.8333	0.9792	932.3228	7.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0979	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94)

i 1	96.8125	0.4896	932.3228	6.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 37 :time 18681)

i 1	97.2969	0.4896	932.3228	6.0100	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 46)

i 1	97.7865	0.4896	932.3228	6.1000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	98.2760	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	98.5208	0.2448	932.3228	5.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 37 :dur 94)

i 1	98.7656	0.4896	932.3228	6.0100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47)

i 1	99.2552	0.2448	932.3228	5.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 26)

i 1	99.5000	0.2448	932.3228	5.0200	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 46 :dur 94 :time 19150)

i 1	99.7396	0.4896	932.3228	6.1000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 44 :dur 47)

i 1	100.2292	0.2448	932.3228	6.0800	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	100.4740	0.2448	932.3228	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 44)

i 1	100.7188	0.2448	932.3228	6.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 42 :dur 24)

i 1	100.9635	0.1250	932.3228	6.0600	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 33)

i 1	101.0885	0.1250	932.3228	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47 :time 19431)

i 1	101.2031	0.2448	932.3228	5.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 24)

i 1	101.4479	0.1250	932.3228	5.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 24)

i 1	101.5729	0.1250	932.3228	5.0000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 37 :dur 94 :time 19525)

i 1	101.6927	0.4896	932.3228	6.0100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0490	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 47)

i 1	102.1823	0.2448	932.3228	5.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 26)

i 1	102.4271	0.2448	932.3228	5.0200	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 35)

i 1	102.6719	0.2448	932.3228	5.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 24)

i 1	102.9167	0.1250	932.3228	5.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 24)

i 1	103.0417	0.1250	932.3228	5.0000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 26 :dur 47 :time 19806)

i 1	103.1563	0.2448	932.3228	5.0200	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 24)

i 1	103.4010	0.1250	932.3228	5.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 15)

i 1	103.5260	0.1250	932.3228	4.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0125	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 192 :time 19900)

i 1	103.6458	1.0000	932.3228	7.0000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.1000	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 154)

i 1	104.6458	0.8021	932.3228	7.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0802	1	1	1	1	1	1	1	1

; (+k :pit 36)

i 1	105.4479	0.8021	932.3228	6.0000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0802	1	1	1	1	1	1	1	1

; (+k :pit 59)

i 1	106.2500	0.8021	932.3228	7.1100	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0802	1	1	1	1	1	1	1	1

; (+k :pit 70 :dur 123)

i 1	107.0521	0.6406	932.3228	8.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0641	1	1	1	1	1	1	1	1

; (+k :pit 47)

i 1	107.6927	0.6406	932.3228	6.1100	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0641	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 154)

i 1	108.3333	0.8021	932.3228	6.0000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0802	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 123)

i 1	109.1354	0.6406	932.3228	6.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0641	1	1	1	1	1	1	1	1

; (+k :pit 24)

i 1	109.7760	0.6406	932.3228	5.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0641	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 114 :vol 110)

i 1	110.4167	0.5938	831.2677	7.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0594	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 143)

i 1	111.0104	0.7448	831.2677	7.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0745	1	1	1	1	1	1	1	1

; (+k :pit 36)

i 1	111.7552	0.7448	831.2677	6.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0745	1	1	1	1	1	1	1	1

; (+k :pit 59)

i 1	112.5000	0.7448	831.2677	7.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0745	1	1	1	1	1	1	1	1

; (+k :pit 70 :dur 179)

i 1	113.2448	0.9323	831.2677	8.1000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0932	1	1	1	1	1	1	1	1

; (+k :pit 47 :time 21921)

i 1	114.1719	0.9323	831.2677	6.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0932	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 143)

i 1	115.1042	0.7448	831.2677	6.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0745	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 179)

i 1	115.8490	0.9323	831.2677	6.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0932	1	1	1	1	1	1	1	1

; (+k :pit 24 :time 22421)

i 1	116.7760	0.9323	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0932	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 122)

i 1	117.7083	0.6354	831.2677	6.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0635	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 91)

i 1	118.3438	0.4740	831.2677	5.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0474	1	1	1	1	1	1	1	1

; (+k :pit 33)

i 1	118.8177	0.4740	831.2677	5.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0474	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	119.2917	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 91)

i 1	119.6510	0.4740	831.2677	5.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0474	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	120.1250	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 30)

i 1	120.4844	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	120.8438	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 91)

i 1	121.1094	0.4740	831.2677	5.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0474	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	121.5833	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 30)

i 1	121.9427	0.3594	831.2677	5.0600	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	122.3021	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	122.5677	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	122.9271	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	123.1927	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	123.4583	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 91)

i 1	123.6615	0.4740	831.2677	5.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0474	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	124.1354	0.3594	831.2677	5.0600	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 30)

i 1	124.4948	0.3594	831.2677	5.0600	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	124.8542	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	125.1198	0.3594	831.2677	5.0600	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	125.4792	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	125.7448	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	126.0104	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	126.2135	0.3594	831.2677	5.0600	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	126.5729	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	126.8385	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	127.1042	0.2031	831.2677	5.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	127.3073	0.2656	831.2677	5.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	127.5729	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 38)

i 1	127.7760	0.1979	831.2677	5.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0198	1	1	1	1	1	1	1	1

; (+k :pit 21 :dur 29)

i 1	127.9740	0.1510	831.2677	4.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0151	1	1	1	1	1	1	1	1

; (+k :pit 33 :dur 91)

i 1	128.1250	0.4740	831.2677	5.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0474	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	128.5990	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 30)

i 1	128.9583	0.3594	831.2677	5.0600	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	129.3177	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	129.5833	0.3594	831.2677	5.0600	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	129.9427	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	130.2083	0.2656	831.2677	5.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	130.4740	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	130.6771	0.3594	831.2677	5.0600	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	131.0365	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	131.3021	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	131.5677	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	131.7708	0.2656	831.2677	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	132.0365	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 38)

i 1	132.2396	0.1979	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0198	1	1	1	1	1	1	1	1

; (+k :pit 21 :dur 29)

i 1	132.4375	0.1510	831.2677	4.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0151	1	1	1	1	1	1	1	1

; (+k :pit 30 :dur 69)

i 1	132.5885	0.3594	831.2677	5.0600	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0359	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	132.9479	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	133.2135	0.2656	831.2677	5.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	133.4792	0.2031	831.2677	5.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	133.6823	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	133.9479	0.2031	831.2677	5.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 38)

i 1	134.1510	0.1979	831.2677	5.0000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0198	1	1	1	1	1	1	1	1

; (+k :pit 21 :dur 29)

i 1	134.3490	0.1510	831.2677	4.0900	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0151	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 51)

i 1	134.5000	0.2656	831.2677	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0266	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 39)

i 1	134.7656	0.2031	831.2677	5.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 24)

i 1	134.9687	0.2031	831.2677	5.0000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0203	1	1	1	1	1	1	1	1

; (+k :pit 21 :dur 29)

i 1	135.1719	0.1510	831.2677	4.0900	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0151	1	1	1	1	1	1	1	1

; (+k :pit 24 :dur 38)

i 1	135.3229	0.1979	831.2677	5.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0198	1	1	1	1	1	1	1	1

; (+k :pit 21 :dur 29)

i 1	135.5208	0.1510	831.2677	4.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0151	1	1	1	1	1	1	1	1

; (+k :pit 21)

i 1	135.6719	0.1510	831.2677	4.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0151	1	1	1	1	1	1	1	1

; (+k :pit 18 :dur 22)

i 1	135.8229	0.1146	831.2677	4.0600	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0115	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 47 :vol 115)

i 1	135.9375	0.2448	776.2835	7.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 57)

i 1	136.1823	0.2448	776.2835	7.0900	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 45 :dur 63)

i 1	136.4271	0.3281	776.2835	6.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 31 :vol 127)

i 1	136.7552	0.1615	819.2000	7.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 47 :vol 115)

i 1	136.9167	0.2448	833.3858	7.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	137.1615	0.2448	833.3858	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63)

i 1	137.4062	0.3281	833.3858	6.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 127)

i 1	137.7344	0.1615	905.6000	7.0700	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 45 :dur 63 :vol 115 :time 26475)

i 1	137.8906	0.3281	895.1181	6.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 43)

i 1	138.2188	0.3281	895.1181	6.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 31 :dur 83 :time 26600)

i 1	138.5417	0.4323	895.1181	5.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 127)

i 1	138.9740	0.2188	835.2000	6.0700	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 31 :vol 115)

i 1	139.1927	0.1615	791.7165	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	139.3542	0.1615	791.7165	7.0700	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :time 26788)

i 1	139.5208	0.2188	791.7165	6.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21 :vol 127 :time 26829)

i 1	139.7344	0.1094	811.2000	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 47 :vol 115)

i 1	139.8438	0.2448	848.8189	7.0900	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	140.0885	0.2448	848.8189	7.0700	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63)

i 1	140.3333	0.3281	848.8189	6.0700	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 127)

i 1	140.6615	0.1615	931.2000	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 47 :vol 115)

i 1	140.8229	0.2448	794.8031	7.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	141.0677	0.2448	794.8031	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 63)

i 1	141.3125	0.3281	794.8031	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 31 :vol 127)

i 1	141.6406	0.1615	934.4000	7.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63 :vol 115 :time 27225)

i 1	141.7969	0.3281	839.5591	6.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	142.1250	0.3281	839.5591	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :time 27350)

i 1	142.4479	0.4323	839.5591	5.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 127)

i 1	142.8802	0.2188	817.6000	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 115)

i 1	143.0990	0.1615	922.8976	7.0700	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	143.2604	0.1615	922.8976	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :time 27538)

i 1	143.4271	0.2188	922.8976	6.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 127 :time 27579)

i 1	143.6406	0.1094	870.4000	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 45 :dur 63 :vol 115)

i 1	143.7500	0.3281	780.9134	6.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 43)

i 1	144.0781	0.3281	780.9134	6.0700	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 31 :dur 83 :time 27725)

i 1	144.4010	0.4323	780.9134	5.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 127)

i 1	144.8333	0.2188	857.6000	6.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63 :vol 115)

i 1	145.0521	0.3281	848.8189	6.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	145.3802	0.3281	848.8189	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :time 27975)

i 1	145.7031	0.4323	848.8189	5.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 127)

i 1	146.1354	0.2188	912.0000	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 31 :dur 83 :vol 115)

i 1	146.3542	0.4323	776.2835	5.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 29)

i 1	146.7865	0.4323	776.2835	5.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 17 :dur 111 :time 28267)

i 1	147.2240	0.5781	776.2835	4.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56 :vol 127)

i 1	147.8021	0.2917	816.0000	5.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 115 :time 28433)

i 1	148.0885	0.2188	825.6693	6.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	148.3073	0.2188	825.6693	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56)

i 1	148.5260	0.2917	825.6693	5.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 127 :time 28572)

i 1	148.8125	0.1458	856.0000	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 31 :vol 115)

i 1	148.9583	0.1615	915.1811	7.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	149.1198	0.1615	915.1811	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :time 28663)

i 1	149.2865	0.2188	915.1811	6.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21 :vol 127 :time 28704)

i 1	149.5000	0.1094	955.2000	7.0700	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 115)

i 1	149.6094	0.1615	899.7480	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	149.7708	0.1615	899.7480	7.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :time 28788)

i 1	149.9375	0.2188	899.7480	6.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 127 :time 28829)

i 1	150.1510	0.1094	955.2000	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 115)

i 1	150.2604	0.2188	831.8425	6.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	150.4792	0.2188	831.8425	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56)

i 1	150.6979	0.2917	831.8425	5.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 127 :time 28989)

i 1	150.9844	0.1458	950.4000	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21 :vol 115)

i 1	151.1302	0.1094	814.8661	7.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	151.2396	0.1094	814.8661	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28)

i 1	151.3490	0.1458	814.8661	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 14 :vol 127 :time 29086)

i 1	151.4896	0.0729	896.0000	7.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 47 :vol 115)

i 1	151.5625	0.2448	879.6850	7.0900	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	151.8073	0.2448	879.6850	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63)

i 1	152.0521	0.3281	879.6850	6.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 127)

i 1	152.3802	0.1615	809.6000	7.0700	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 47 :vol 115)

i 1	152.5417	0.2448	771.6535	7.0700	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	152.7865	0.2448	771.6535	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 63)

i 1	153.0312	0.3281	771.6535	6.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 31 :vol 127)

i 1	153.3594	0.1615	907.2000	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63 :vol 115 :time 29475)

i 1	153.5156	0.3281	919.8110	6.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	153.8438	0.3281	919.8110	6.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :time 29600)

i 1	154.1667	0.4323	919.8110	5.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 127)

i 1	154.5990	0.2188	926.4000	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 115)

i 1	154.8177	0.1615	862.7087	7.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	154.9792	0.1615	862.7087	7.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :time 29788)

i 1	155.1458	0.2188	862.7087	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 127 :time 29829)

i 1	155.3594	0.1094	889.6000	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 47 :vol 115)

i 1	155.4688	0.2448	890.4882	7.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	155.7135	0.2448	890.4882	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 63)

i 1	155.9583	0.3281	890.4882	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 31 :vol 127)

i 1	156.2865	0.1615	912.0000	7.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 47 :vol 115)

i 1	156.4479	0.2448	904.3780	7.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	156.6927	0.2448	904.3780	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0245	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 63)

i 1	156.9375	0.3281	904.3780	6.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 31 :vol 127)

i 1	157.2656	0.1615	897.6000	7.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 63 :vol 115 :time 30225)

i 1	157.4219	0.3281	814.8661	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	157.7500	0.3281	814.8661	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 83 :time 30350)

i 1	158.0729	0.4323	814.8661	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 42 :vol 127)

i 1	158.5052	0.2188	921.6000	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 31 :vol 115)

i 1	158.7240	0.1615	811.7795	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	158.8854	0.1615	811.7795	7.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 42 :time 30538)

i 1	159.0521	0.2188	811.7795	6.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 21 :vol 127 :time 30579)

i 1	159.2656	0.1094	899.2000	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63 :vol 115)

i 1	159.3750	0.3281	913.6378	6.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	159.7031	0.3281	913.6378	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :time 30725)

i 1	160.0260	0.4323	913.6378	5.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 127)

i 1	160.4583	0.2188	817.6000	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 63 :vol 115)

i 1	160.6771	0.3281	882.7717	6.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	161.0052	0.3281	882.7717	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 83 :time 30975)

i 1	161.3281	0.4323	882.7717	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 42 :vol 127)

i 1	161.7604	0.2188	940.8000	6.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :vol 115)

i 1	161.9792	0.4323	847.2756	5.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	162.4115	0.4323	847.2756	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 111 :time 31267)

i 1	162.8490	0.5781	847.2756	4.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56 :vol 127)

i 1	163.4271	0.2917	852.8000	5.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 115 :time 31433)

i 1	163.7135	0.2188	780.9134	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	163.9323	0.2188	780.9134	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56)

i 1	164.1510	0.2917	780.9134	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28 :vol 127 :time 31572)

i 1	164.4375	0.1458	912.0000	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 115)

i 1	164.5833	0.1615	893.5748	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	164.7448	0.1615	893.5748	7.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :time 31663)

i 1	164.9115	0.2188	893.5748	6.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 127 :time 31704)

i 1	165.1250	0.1094	830.4000	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 31 :vol 115)

i 1	165.2344	0.1615	907.4646	7.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	165.3958	0.1615	907.4646	7.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 42 :time 31788)

i 1	165.5625	0.2188	907.4646	6.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 21 :vol 127 :time 31829)

i 1	165.7760	0.1094	860.8000	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 115)

i 1	165.8854	0.2188	898.2047	6.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	166.1042	0.2188	898.2047	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56)

i 1	166.3229	0.2917	898.2047	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28 :vol 127 :time 31989)

i 1	166.6094	0.1458	948.8000	6.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 115)

i 1	166.7552	0.1094	918.2677	7.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	166.8646	0.1094	918.2677	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28)

i 1	166.9740	0.1458	918.2677	6.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 14 :vol 127 :time 32086)

i 1	167.1146	0.0729	924.8000	7.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 45 :dur 63 :vol 115)

i 1	167.1875	0.3281	825.6693	6.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 43)

i 1	167.5156	0.3281	825.6693	6.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 31 :dur 83 :time 32225)

i 1	167.8385	0.4323	825.6693	5.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 127)

i 1	168.2708	0.2188	800.0000	6.0700	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63 :vol 115)

i 1	168.4896	0.3281	787.0866	6.0700	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	168.8177	0.3281	787.0866	6.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :time 32475)

i 1	169.1406	0.4323	787.0866	5.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 127)

i 1	169.5729	0.2188	846.4000	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 31 :dur 83 :vol 115)

i 1	169.7917	0.4323	790.1732	5.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 29)

i 1	170.2240	0.4323	790.1732	5.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 17 :dur 111 :time 32767)

i 1	170.6615	0.5781	790.1732	4.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56 :vol 127)

i 1	171.2396	0.2917	859.2000	5.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 115 :time 32933)

i 1	171.5260	0.2188	868.8819	6.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	171.7448	0.2188	868.8819	6.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56)

i 1	171.9635	0.2917	868.8819	5.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 127 :time 33072)

i 1	172.2500	0.1458	857.6000	6.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 63 :vol 115)

i 1	172.3958	0.3281	838.0157	6.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	172.7240	0.3281	838.0157	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :time 33225)

i 1	173.0469	0.4323	838.0157	5.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 127)

i 1	173.4792	0.2188	840.0000	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 63 :vol 115)

i 1	173.6979	0.3281	793.2598	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	174.0260	0.3281	793.2598	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0328	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 83 :time 33475)

i 1	174.3490	0.4323	793.2598	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 42 :vol 127)

i 1	174.7813	0.2188	889.6000	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :vol 115)

i 1	175.0000	0.4323	822.5827	5.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	175.4323	0.4323	822.5827	5.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 111 :time 33767)

i 1	175.8698	0.5781	822.5827	4.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56 :vol 127)

i 1	176.4479	0.2917	864.0000	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 115 :time 33933)

i 1	176.7344	0.2188	773.1969	6.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	176.9531	0.2188	773.1969	6.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56)

i 1	177.1719	0.2917	773.1969	5.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28 :vol 127 :time 34072)

i 1	177.4583	0.1458	800.0000	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 31 :dur 83 :vol 115)

i 1	177.6042	0.4323	805.6063	5.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 29)

i 1	178.0365	0.4323	805.6063	5.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 17 :dur 111 :time 34267)

i 1	178.4740	0.5781	805.6063	4.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56 :vol 127)

i 1	179.0521	0.2917	934.4000	5.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 83 :vol 115 :time 34433)

i 1	179.3385	0.4323	804.0630	5.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	179.7708	0.4323	804.0630	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0432	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 111 :time 34600)

i 1	180.2083	0.5781	804.0630	4.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56 :vol 127)

i 1	180.7865	0.2917	872.0000	5.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 17 :dur 111 :vol 115)

i 1	181.0781	0.5781	771.6535	4.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 15)

i 1	181.6563	0.5781	771.6535	4.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0578	1	1	1	1	1	1	1	1

; (+k :pit 3 :dur 148)

i 1	182.2344	0.7708	771.6535	3.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0771	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 74 :vol 127)

i 1	183.0052	0.3854	827.2000	4.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0385	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56 :vol 115)

i 1	183.3906	0.2917	885.8583	5.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	183.6823	0.2917	885.8583	5.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 74 :time 35322)

i 1	183.9688	0.3854	885.8583	4.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0385	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 37 :vol 127)

i 1	184.3542	0.1927	924.8000	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0193	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 115)

i 1	184.5469	0.2188	885.8583	6.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	184.7656	0.2188	885.8583	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56)

i 1	184.9844	0.2917	885.8583	5.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 127 :time 35572)

i 1	185.2708	0.1458	849.6000	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 115)

i 1	185.4167	0.2188	850.3622	6.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	185.6354	0.2188	850.3622	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56)

i 1	185.8542	0.2917	850.3622	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28 :vol 127 :time 35739)

i 1	186.1406	0.1458	801.6000	6.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56 :vol 115)

i 1	186.2865	0.2917	892.0315	5.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	186.5781	0.2917	892.0315	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 74 :time 35878)

i 1	186.8646	0.3854	892.0315	4.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0385	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 37 :vol 127)

i 1	187.2500	0.1927	920.0000	5.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0193	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 115)

i 1	187.4427	0.1458	881.2283	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	187.5885	0.1458	881.2283	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 37)

i 1	187.7344	0.1927	881.2283	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0193	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 19 :vol 127)

i 1	187.9271	0.0990	931.2000	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0099	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 31 :vol 115 :time 36100)

i 1	188.0208	0.1615	831.8425	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 55)

i 1	188.1823	0.1615	831.8425	7.0700	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :time 36163)

i 1	188.3490	0.2188	831.8425	6.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21 :vol 127 :time 36204)

i 1	188.5625	0.1094	859.2000	7.0700	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 115)

i 1	188.6719	0.1615	882.7717	7.0700	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	188.8333	0.1615	882.7717	7.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :time 36288)

i 1	189.0000	0.2188	882.7717	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 127 :time 36329)

i 1	189.2135	0.1094	891.2000	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 115)

i 1	189.3229	0.2188	910.5512	6.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	189.5417	0.2188	910.5512	6.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56)

i 1	189.7604	0.2917	910.5512	5.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 127 :time 36489)

i 1	190.0469	0.1458	902.4000	6.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21 :vol 115)

i 1	190.1927	0.1094	850.3622	7.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	190.3021	0.1094	850.3622	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28)

i 1	190.4115	0.1458	850.3622	6.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 14 :vol 127 :time 36586)

i 1	190.5521	0.0729	928.0000	7.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 31 :vol 115)

i 1	190.6250	0.1615	831.8425	7.0700	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	190.7865	0.1615	831.8425	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :time 36663)

i 1	190.9531	0.2188	831.8425	6.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 127 :time 36704)

i 1	191.1667	0.1094	865.6000	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 31 :vol 115)

i 1	191.2760	0.1615	847.2756	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	191.4375	0.1615	847.2756	7.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0161	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 42 :time 36788)

i 1	191.6042	0.2188	847.2756	6.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 21 :vol 127 :time 36829)

i 1	191.8177	0.1094	841.6000	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 115)

i 1	191.9271	0.2188	884.3150	6.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	192.1458	0.2188	884.3150	6.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56)

i 1	192.3646	0.2917	884.3150	5.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28 :vol 127 :time 36989)

i 1	192.6510	0.1458	835.2000	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 115)

i 1	192.7969	0.1094	921.3543	7.0500	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	192.9063	0.1094	921.3543	7.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28)

i 1	193.0156	0.1458	921.3543	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 14 :vol 127 :time 37086)

i 1	193.1563	0.0729	865.6000	7.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 43 :dur 42 :vol 115)

i 1	193.2292	0.2188	822.5827	6.0700	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 41)

i 1	193.4479	0.2188	822.5827	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56)

i 1	193.6667	0.2917	822.5827	5.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 127 :time 37239)

i 1	193.9531	0.1458	955.2000	6.0500	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 42 :vol 115)

i 1	194.0990	0.2188	919.8110	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	194.3177	0.2188	919.8110	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0219	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 56)

i 1	194.5365	0.2917	919.8110	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28 :vol 127 :time 37406)

i 1	194.8229	0.1458	876.8000	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 29 :dur 56 :vol 115)

i 1	194.9688	0.2917	804.0630	5.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 27)

i 1	195.2604	0.2917	804.0630	5.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0292	1	1	1	1	1	1	1	1

; (+k :pit 15 :dur 74 :time 37545)

i 1	195.5469	0.3854	804.0630	4.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0385	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 37 :vol 127)

i 1	195.9323	0.1927	848.0000	5.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0193	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 115)

i 1	196.1250	0.1458	870.4252	6.0500	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	196.2708	0.1458	870.4252	6.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 37)

i 1	196.4167	0.1927	870.4252	5.0300	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0193	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 19 :vol 127)

i 1	196.6094	0.0990	945.6000	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0099	1	1	1	1	1	1	1	1

; (+k :pit 55 :dur 21 :vol 115 :time 37767)

i 1	196.7031	0.1094	875.0551	7.0700	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 53)

i 1	196.8125	0.1094	875.0551	7.0500	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28)

i 1	196.9219	0.1458	875.0551	6.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 14 :vol 127 :time 37836)

i 1	197.0625	0.0729	841.6000	7.0500	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 21 :vol 115)

i 1	197.1354	0.1094	805.6063	7.0500	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	197.2448	0.1094	805.6063	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0109	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 28)

i 1	197.3542	0.1458	805.6063	6.0300	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 14 :vol 127 :time 37919)

i 1	197.4948	0.0729	868.8000	7.0300	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 41 :dur 28 :vol 115 :time 37934)

i 1	197.5729	0.1458	833.3858	6.0500	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 39)

i 1	197.7188	0.1458	833.3858	6.0300	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0146	1	1	1	1	1	1	1	1

; (+k :pit 27 :dur 37)

i 1	197.8646	0.1927	833.3858	5.0300	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0193	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 19 :vol 127)

i 1	198.0573	0.0990	897.6000	6.0300	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0099	1	1	1	1	1	1	1	1

; (+k :pit 53 :dur 14 :vol 115 :time 38045)

i 1	198.1510	0.0729	819.4961	7.0500	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 51)

i 1	198.2240	0.0729	819.4961	7.0300	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0073	1	1	1	1	1	1	1	1

; (+k :pit 39 :dur 19)

i 1	198.2969	0.0990	819.4961	6.0300	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0099	1	1	1	1	1	1	1	1

; (+k :pit 51 :dur 9 :vol 127)

i 1	198.3958	0.0469	889.6000	7.0300	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0047	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 64 :vol 110 :time 38100)

i 1	198.4375	0.3333	787.1969	6.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 48)

i 1	198.7708	0.2500	787.1969	6.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 47)

i 1	199.0208	0.2500	787.1969	6.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 64 :vol 120)

i 1	199.2708	0.3333	882.1811	7.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 48)

i 1	199.6042	0.2500	882.1811	7.0000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 64)

i 1	199.8542	0.3333	882.1811	7.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 57)

i 1	200.1875	0.3333	882.1811	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 48 :vol 110)

i 1	200.5208	0.2500	890.5354	6.0000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 36 :dur 36)

i 1	200.7708	0.1875	890.5354	6.0000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 47)

i 1	200.9583	0.1875	890.5354	6.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 48 :vol 120)

i 1	201.1458	0.2500	879.0472	7.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 36)

i 1	201.3958	0.1875	879.0472	7.0000	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 48)

i 1	201.5833	0.2500	879.0472	7.0000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 57)

i 1	201.8333	0.2500	879.0472	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 47 :vol 110)

i 1	202.0833	0.2500	904.2126	6.1100	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 47 :dur 36)

i 1	202.3333	0.1875	904.2126	6.1100	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 58)

i 1	202.5208	0.1875	904.2126	7.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 70 :dur 48 :vol 120)

i 1	202.7083	0.2500	830.4724	8.1000	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 36)

i 1	202.9583	0.1875	830.4724	7.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 48)

i 1	203.1458	0.2500	830.4724	7.1100	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 68)

i 1	203.3958	0.2500	830.4724	8.0800	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 64 :vol 110)

i 1	203.6458	0.3333	834.3071	7.1100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 59 :dur 48)

i 1	203.9792	0.2500	834.3071	7.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 70)

i 1	204.2292	0.2500	834.3071	8.1000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 82 :dur 64 :vol 120)

i 1	204.4792	0.3333	814.8031	9.1000	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 71 :dur 48)

i 1	204.8125	0.2500	814.8031	8.1100	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 71 :dur 64)

i 1	205.0625	0.3333	814.8031	8.1100	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 80)

i 1	205.3958	0.3333	814.8031	9.0800	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 48 :vol 110)

i 1	205.7292	0.2500	835.8268	7.0000	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 36)

i 1	205.9792	0.1875	835.8268	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 59)

i 1	206.1667	0.1875	835.8268	7.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 71 :dur 48 :vol 120)

i 1	206.3542	0.2500	803.8346	8.1100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 60 :dur 36)

i 1	206.6042	0.1875	803.8346	8.0000	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0188	1	1	1	1	1	1	1	1

; (+k :pit 60 :dur 48)

i 1	206.7917	0.2500	803.8346	8.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 69)

i 1	207.0417	0.2500	803.8346	8.0900	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 64 :vol 110)

i 1	207.2917	0.3333	825.1890	7.0000	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 48)

i 1	207.6250	0.2500	825.1890	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 59)

i 1	207.8750	0.2500	825.1890	7.1100	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 71 :dur 64 :vol 120)

i 1	208.1250	0.3333	827.3386	8.1100	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 60 :dur 48)

i 1	208.4583	0.2500	827.3386	8.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 60 :dur 64)

i 1	208.7083	0.3333	827.3386	8.0000	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 69)

i 1	209.0417	0.3333	827.3386	8.0900	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 57 :vol 110)

i 1	209.3750	0.3333	852.5433	7.0900	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 57 :dur 48)

i 1	209.7083	0.2500	852.5433	7.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 68)

i 1	209.9583	0.2500	852.5433	8.0800	4	12	0	0	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	2	2	2	2	4	8	8	8	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 80 :dur 64 :vol 120)

i 1	210.2083	0.3333	847.7087	9.0800	4	12	0	0	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	2	4	8	8	8	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 69 :dur 48)

i 1	210.5417	0.2500	847.7087	8.0900	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	8	8	2	2	2	2	2	2	4	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0250	1	1	1	1	1	1	1	1

; (+k :pit 69 :dur 64)

i 1	210.7917	0.3333	847.7087	8.0900	4	12	0	0	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	2	2	2	2	2	4	8	8	8	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 78)

i 1	211.1250	0.3333	847.7087	9.0600	4	12	0	0	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	2	2	4	8	8	8	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0333	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 800 :vol 127)

i 1	211.4583	4.1667	944.0000	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	8	8	8	2	2	2	2	2	2	4	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.4167	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 600)

i 1	215.6250	3.1250	944.0000	5.1100	4	12	0	0	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	2	2	2	2	2	2	4	8	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.3125	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 150)

i 1	218.7500	0.7813	944.0000	5.1100	4	12	0	0	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	2	2	2	4	8	8	8	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.0781	1	1	1	1	1	1	1	1

; (+k :pit 35 :dur 700 :vol 60)

i 1	219.5313	3.6458	727.7244	5.1100	4	12	0	0	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	0.2000	0.2000	0.2000	4	8	8	8	2	2	2	2	2	2	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.3646	1	1	1	1	1	1	1	1

; (+k :pit 48 :dur 1500 :vol 35)

i 1	223.1771	7.8125	658.4252	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.7813	1	1	1	1	1	1	1	1

i 1	230.9896	1	0	7.0000	4	12	0	0	0.2000	0.2000	0.2000	0.2000	0.2000	0.4000	0.8000	0.8000	0.8000	0.1000	8	2	2	2	2	2	2	4	8	8	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0.5000	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	0	0	0	0	0	0	0	0	0	1	1	1	1	1	1	1	1	1	1	0.7813	1	1	1	1	1	1	1	1
 
e
</CsScore>
</CsoundSynthesizer>
